variables:
  _flow_doc_src_documentation: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/doc/doc_validate.sh"
  _flow_doc_img_documentation: alpine:latest
  _flow_doc_src_fundamentals: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/doc/doc_fundamentals.sh"
  _flow_doc_img_fundamentals: alpine:latest
  _flow_doc_src_lint: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/doc/doc_lint.sh"
  _flow_doc_img_lint: node:hydrogen-alpine3.18
  _flow_doc_src_wiki: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/doc/wiki.sh"
  _flow_doc_img_wiki: alpine:latest


validate documentation:
  stage: validate
  image: $_flow_doc_img_documentation
  dependencies: []
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-common "$_flow_common_sh_src"
    - wget -q -O /usr/bin/flow-documentation "$_flow_doc_src_documentation"
    - chmod +x /usr/bin/flow-documentation
  script:
    - /usr/bin/flow-documentation validate
  rules:
    - if: $CI_PIPELINE_SOURCE != 'merge_request_event'
      when: never
    - if: $_flow_doc != "true"
      when: never
    - if: $_flow_doc_validate != "true"
      when: never
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_prod_branch && $_flow_prod_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env1_branch && $_flow_env1_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env2_branch && $_flow_env2_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env3_branch && $_flow_env3_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env4_branch && $_flow_env4_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env5_branch && $_flow_env5_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env6_branch && $_flow_env6_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env7_branch && $_flow_env7_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env8_branch && $_flow_env8_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env9_branch && $_flow_env9_doc == 'true'
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
    reports:
      codequality: ${_flow_reports_path}/codequality/${_flow_report_doc_validate}


validate fundamentals:
  stage: validate
  image: $_flow_doc_img_fundamentals
  dependencies: []
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-common "$_flow_common_sh_src"
    - wget -q -O /usr/bin/flow-documentation "$_flow_doc_src_fundamentals"
    - chmod +x /usr/bin/flow-documentation
  script:
    - /usr/bin/flow-documentation validate
  rules:
    - if: $CI_PIPELINE_SOURCE != 'merge_request_event'
      when: never
    - if: $_flow_doc != "true"
      when: never
    - if: $_flow_doc_fundamentals != "true"
      when: never
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_prod_branch && $_flow_prod_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env1_branch && $_flow_env1_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env2_branch && $_flow_env2_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env3_branch && $_flow_env3_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env4_branch && $_flow_env4_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env5_branch && $_flow_env5_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env6_branch && $_flow_env6_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env7_branch && $_flow_env7_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env8_branch && $_flow_env8_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env9_branch && $_flow_env9_doc == 'true'
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
    reports:
      codequality: ${_flow_reports_path}/codequality/${_flow_report_doc_fundamentals}


lint documentation:
  stage: validate
  image: $_flow_doc_img_lint
  dependencies: []
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-documentation "$_flow_doc_src_lint"
    - chmod +x /usr/bin/flow-documentation
    - npm install markdownlint-cli2 --global --no-fund
    - npm install markdownlint-cli2-formatter-codequality --global --no-fund
  script:
    - /usr/bin/flow-documentation lint
  rules:
    - if: $CI_PIPELINE_SOURCE != 'merge_request_event'
      when: never
    - if: $_flow_doc != "true"
      when: never
    - if: $_flow_doc_lint != "true"
      when: never
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_prod_branch && $_flow_prod_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env1_branch && $_flow_env1_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env2_branch && $_flow_env2_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env3_branch && $_flow_env3_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env4_branch && $_flow_env4_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env5_branch && $_flow_env5_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env6_branch && $_flow_env6_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env7_branch && $_flow_env7_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env8_branch && $_flow_env8_doc == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env9_branch && $_flow_env9_doc == 'true'
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
    reports:
      codequality: ${_flow_reports_path}/codequality/${_flow_report_doc_lint}


wiki:
  stage: release
  image: $_flow_doc_img_wiki
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-wiki "$_flow_doc_src_wiki"
    - chmod +x /usr/bin/flow-wiki
    - apk add git
  script:
    - /usr/bin/flow-wiki release
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      when: never
    - if: $_flow_doc != "true"
      when: never
    - if: $_flow_doc_wiki != "true"
      when: never
    - if: $CI_COMMIT_BRANCH == $_flow_prod_branch
